---
title: 'Forgejo Developer Guide'
---

This area will be targeted to people who want to hack Forgejo and adjust it to
their needs.

- For everyone involved
  - [Code of Conduct](./coc/)
  - [Bugs, features, security and others discussions](./discussions/)
  - [Governance](./governance/)
  - [Sustainability and funding](https://codeberg.org/forgejo/sustainability)
- For contributors
  - [Compiling from source](./from-source/)
  - [Testing](./testing/)
  - [Development environment](./development-environment/)
  - [Interface customization](./customization/)
  - [Architecture overview](./architecture/)
    - [Federation Architecture](./federation-architecture/)
    - [Federation Architectural Decision Records](./adr/)
  - [Threat Analysis](./threat-analysis/)
  - [Developer Certificate of Origin (DCO)](./dco/)
  - [code.forgejo.org](./code-forgejo-org/)
  - [next.forgejo.org](./next-forgejo-org/)
  - [static pages](./static-pages/)
  - [Forgejo runner implementation notes](https://code.forgejo.org/forgejo/runner/#hacking)
  - [Localization](./localization/)
  - [Base localization](./localization-english/)
  - [Localization admin duties](./localization-admin/)
  - [Dependency management](./dependencies/)
- For maintainers
  - [Hardware infrastructure](./infrastructure/)
  - [Release management](./release/)
  - [Managing dependencies between repositories](./repositories-dependencies/)
  - [Secrets](./secrets/)
